import { Construct } from 'constructs';
import { TerraformDataSource } from 'cdktf';
import { TerraformMetaArguments } from 'cdktf';
import { ComplexComputedList } from "cdktf";
/**
 *
 */
export interface DataKubernetesServiceConfig extends TerraformMetaArguments {
    /**
     * metadata block.
     */
    readonly metadata: DataKubernetesServiceMetadata[];
}
/**
 *
 */
export declare class DataKubernetesServiceLoadBalancerIngress extends ComplexComputedList {
    /**
     *
     */
    get hostname(): string;
    /**
     *
     */
    get ip(): string;
}
/**
 *
 */
export declare class DataKubernetesServiceSpecPort extends ComplexComputedList {
    /**
     *
     */
    get name(): string;
    /**
     *
     */
    get nodePort(): number;
    /**
     *
     */
    get port(): number;
    /**
     *
     */
    get protocol(): string;
    /**
     *
     */
    get targetPort(): string;
}
/**
 *
 */
export declare class DataKubernetesServiceSpec extends ComplexComputedList {
    /**
     *
     */
    get clusterIp(): string;
    /**
     *
     */
    get externalIps(): string[];
    /**
     *
     */
    get externalName(): string;
    /**
     *
     */
    get externalTrafficPolicy(): string;
    /**
     *
     */
    get healthCheckNodePort(): number;
    /**
     *
     */
    get loadBalancerIp(): string;
    /**
     *
     */
    get loadBalancerSourceRanges(): string[];
    /**
     *
     */
    get port(): any;
    /**
     *
     */
    get publishNotReadyAddresses(): boolean;
    /**
     *
     */
    get selector(): any;
    /**
     *
     */
    get sessionAffinity(): string;
    /**
     *
     */
    get type(): string;
}
/**
 *
 */
export interface DataKubernetesServiceMetadata {
    /**
     * An unstructured key value map stored with the service that may be used to store arbitrary metadata.
     *
     * More info: http://kubernetes.io/docs/user-guide/annotations
     */
    readonly annotations?: {
        [key: string]: string;
    };
    /**
     * Map of string keys and values that can be used to organize and categorize (scope and select) the service.
     *
     * May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels
     */
    readonly labels?: {
        [key: string]: string;
    };
    /**
     * Name of the service, must be unique.
     *
     * Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names
     */
    readonly name?: string;
    /**
     * Namespace defines the space within which name of the service must be unique.
     */
    readonly namespace?: string;
}
/**
 *
 */
export declare class DataKubernetesService extends TerraformDataSource {
    /**
     *
     */
    constructor(scope: Construct, id: string, config: DataKubernetesServiceConfig);
    private _id?;
    /**
     *
     */
    get id(): string | undefined;
    /**
     *
     */
    set id(value: string | undefined);
    /**
     *
     */
    loadBalancerIngress(index: string): DataKubernetesServiceLoadBalancerIngress;
    /**
     *
     */
    spec(index: string): DataKubernetesServiceSpec;
    private _metadata;
    /**
     *
     */
    get metadata(): DataKubernetesServiceMetadata[];
    /**
     *
     */
    set metadata(value: DataKubernetesServiceMetadata[]);
    /**
     *
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
